OpenTTD Source: src/widgets/dropdown_func.h File Reference

OpenTTD Source 13.1

Functions
dropdown_func.h File Reference
`#include "../window_gui.h"`

Go to the source code of this file.

## Functions
void | ShowDropDownMenu (Window *w, const StringID *strings, int selected, int button, uint32 disabled_mask, uint32 hidden_mask, uint width=0)
| Show a dropdown menu window near a widget of the parent window. More...
int | HideDropDownMenu (Window *pw)
| Delete the drop-down menu from window pw. More...

## Detailed Description

Functions related to the drop down widget.

Definition in file dropdown_func.h.

## Function Documentation

## ◆ HideDropDownMenu()

int HideDropDownMenu | ( | Window * | pw | ) |

Delete the drop-down menu from window pw.

Parameters

  pw | Parent window of the drop-down menu window

Returns
  Parent widget number if the drop-down was found and closed, `-1` if the window was not found.

Definition at line 505 of file dropdown.cpp.

References DropdownWindow::Close(), DropdownWindow::parent_button, DropdownWindow::parent_wnd_class, DropdownWindow::parent_wnd_num, WC_DROPDOWN_MENU, Window::window_class, and Window::window_number.

Referenced by NewGRFParametersWindow::OnClick(), AISettingsWindow::OnClick(), AISettingsWindow::OnInvalidateData(), OrdersWindow::OnInvalidateData(), VehicleGroupWindow::OnPaint(), and VehicleListWindow::OnPaint().

## ◆ ShowDropDownMenu()

void ShowDropDownMenu | ( | Window * | w,
|  | const StringID * | strings,
|  | int | selected,
|  | int | button,
|  | uint32 | disabled_mask,
|  | uint32 | hidden_mask,
|  | uint | width
| ) |  |

Show a dropdown menu window near a widget of the parent window.

The result code of the items is their index in the strings list.

Parameters

  w | Parent window that wants the dropdown menu.
  strings | Menu list, end with INVALID_STRING_ID
  selected | Index of initial selected item.
  button | Button widget number of the parent window w that wants the dropdown menu.
  disabled_mask | Bitmask for disabled items (items with their bit set are displayed, but not selectable in the dropdown list).
  hidden_mask | Bitmask for hidden items (items with their bit set are not copied to the dropdown list).
  width | Width of the dropdown menu. If `0`, use the width of parent widget button.

Definition at line 487 of file dropdown.cpp.

References HasBit(), INVALID_STRING_ID, and ShowDropDownList().

Referenced by BuildBridgeWindow::OnClick(), CompanyStationsWindow::OnClick(), VehicleGroupWindow::OnClick(), TownDirectoryWindow::OnClick(), BuildVehicleWindow::OnClick(), IndustryDirectoryWindow::OnClick(), and VehicleDetailsWindow::OnClick().